-- PripojeniDokumentuKVyrCK.HQL
-- Dokumenty pripojene ke stavu VC (tabVyrCS) pripoji ke kmenove karte VC (tabVyrCK).
-- Pokud se nastavi parametr @SMazanim = 1, zrusi se pripojeni dokumentu ke stavum VC.
-- Skript lze spustit opakovane, tj. nejprve bez mazani a podruhe s mazanim v tabVyrCS.


-- IdentVazby:
-- 39 = TabVyrCS
-- 83 = TabVyrCK

-- Pro testovani ulozenou procedurou
-- IF OBJECT_ID ('dbo.hp_PripojeniDokumentuKVyrCK') IS NOT NULL
--        DROP PROC dbo.hp_PripojeniDokumentuKVyrCK
-- GO
-- CREATE PROC dbo.hp_PripojeniDokumentuKVyrCK @SMazanim BIT = 0
--AS


DECLARE @SMazanim BIT -- pro skript bez zakladani procedury
DECLARE @IdVyrCK INT
DECLARE @IdVyrCS INT
DECLARE @IdDok INT

SET @SMazanim = 0 -- bez mazani pripojeni dokum. ke stavu VC - TabVyrCS (1 s mazanim)
--kurzor pres TabVyrCK
DECLARE C_VyrCK CURSOR FOR SELECT Id FROM TabVyrCK 
OPEN C_VyrCK
WHILE 1=1
BEGIN
       FETCH NEXT FROM C_VyrCK INTO @IdVyrCK
       IF @@FETCH_STATUS<>0 BREAK

       --kurzor pres navazane dokumenty na TabVyrCS
       DECLARE C_VyrCS CURSOR FOR 
       SELECT DISTINCT V.IdDok 
       FROM TabDokumVazba V
       JOIN TabVyrCS S ON S.ID=V.IdTab
       WHERE V.IdentVazby = 39 AND S.IdVyrCK=@IdVyrCK
       OPEN C_VyrCS
       WHILE 1=1
       BEGIN
             FETCH NEXT FROM C_VyrCS INTO @IdDok
             IF @@FETCH_STATUS<>0 BREAK
-- doplneni neexistujicich vazeb
             IF NOT EXISTS (SELECT * FROM TabDokumVazba WHERE IdentVazby=83 AND IdTab=@IdVyrCK AND IdDok=@IdDok)
             INSERT TabDokumVazba(IdentVazby, IdTab, IdTab2, IdTab3, IdDok)
             VALUES (83, @IdVyrCK, 0, 0, @IdDok)

-- smazani vazeb na TabVyrCS (pokud je nastaven parametr @SMazanim = 1) 
             IF @SMazanim = 1
                    DELETE FROM TabDokumVazba WHERE IdentVazby=39 AND IdDok=@IdDok AND IdTab IN (SELECT ID FROM TabVyrCS WHERE IdVyrCK=@IdVyrCK)
       END
       CLOSE C_VyrCS
       DEALLOCATE C_VyrCS  
END
CLOSE C_VyrCK
DEALLOCATE C_VyrCK
-- GO


--pro testovani s pouzitim ulozene procedury (ve zrusene transakci, at nemusim porad vytvaret dokumenty)
-- BEGIN TRAN
--volani bez mazani vazeb na TabVyrCS
-- EXEC dbo.hp_PripojeniDokumentuKVyrCK
-- SELECT * FROM TabDokumVazba

--volani s mazanim vazeb na TabVyrCS
-- EXEC dbo.hp_PripojeniDokumentuKVyrCK 1
-- SELECT * FROM TabDokumVazba

-- ROLLBACK
